mescc: Support gcc-3.4.0: unsetenv.
[mes.git] / build-aux / check-mescc.sh
1 #! /bin/sh
2
3 # Mes --- Maxwell Equations of Software
4 # Copyright © 2017,2018 Jan (janneke) Nieuwenhuizen <janneke@gnu.org>
5 #
6 # This file is part of Mes.
7 #
8 # Mes is free software; you can redistribute it and/or modify it
9 # under the terms of the GNU General Public License as published by
10 # the Free Software Foundation; either version 3 of the License, or (at
11 # your option) any later version.
12 #
13 # Mes is distributed in the hope that it will be useful, but
14 # WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with Mes.  If not, see <http://www.gnu.org/licenses/>.
20
21 if [ -n "$BUILD_DEBUG" ]; then
22     set -x
23 fi
24
25 export BLOOD_ELF GUILE HEX2 M1 MES MESCC
26 export M1FLAGS HEX2FLAGS PREPROCESS
27 export MES_ARENA MES_PREFIX MES_SEED
28 export BUILD_DEBUG
29 export LIBC CC32LIBS MESCCLIBS
30
31 MES=${MES-src/mes}
32 MESCC=${MESCC-scripts/mescc}
33 GUILE=${GUILE-guile}
34 MES_PREFIX=${MES_PREFIX-.}
35
36 HEX2=${HEX2-hex2}
37 M1=${M1-M1}
38 BLOOD_ELF=${BLOOD_ELF-blood-elf}
39 MES_SEED=${MES_SEED-../mes-seed}
40 MESCC=${MESCC-$(command -v mescc)}
41 [ -z "$MESCC" ] && MESCC=scripts/mescc
42 MES=${MES-$(command -v mes)}
43 [ -z "$MES" ] && MES=src/mes
44
45 if ! command -v $GUILE > /dev/null; then
46     GUILE=true
47 fi
48
49 tests="
50 t
51 00-exit-0
52 01-return-0
53 02-return-1
54 03-call
55 04-call-0
56 05-call-1
57 06-call-!1
58 10-if-0
59 11-if-1
60 12-if-==
61 13-if-!=
62 14-if-goto
63 15-if-!f
64 16-if-t
65 20-while
66 21-char[]
67 22-while-char[]
68 23-pointer
69 30-strlen
70 31-eputs
71 32-compare
72 33-and-or
73 34-pre-post
74 35-compare-char
75 36-compare-arithmetic
76 37-compare-assign
77 38-compare-call
78 40-if-else
79 41-?
80 42-goto-label
81 43-for-do-while
82 44-switch
83 45-void-call
84 46-function-static
85 47-function-expression
86 48-function-destruct
87 49-global-static
88 4a-char-array
89 50-assert
90 51-strcmp
91 52-itoa
92 53-strcpy
93 54-argv
94 60-math
95 61-array
96 62-array
97 63-struct-cell
98 64-make-cell
99 65-read
100 70-printf
101 71-struct-array
102 72-typedef-struct-def
103 73-union
104 74-multi-line-string
105 75-struct-union
106 76-pointer-arithmetic
107 77-pointer-assign
108 78-union-struct
109 79-int-array
110 7a-struct-char-array
111 7b-struct-int-array
112 7c-dynarray
113 7d-cast-char
114 7e-struct-array-access
115 7f-struct-pointer-arithmetic
116 7g-struct-byte-word-field
117 7h-struct-assign
118 7i-struct-struct
119 7j-strtoull
120 7k-for-each-elem
121 7l-struct-any-size-array
122 7m-struct-char-array-assign
123 7n-struct-struct-array
124 7o-struct-pre-post
125 7p-struct-cast
126 7q-bit-field
127 7r-sign-extend
128 7s-struct-short
129 80-setjmp
130 81-qsort
131 82-define
132 83-heterogenoous-init
133 84-struct-field-list
134 85-sizeof
135 86-strncpy
136 87-sscanf
137 90-strpbrk
138 91-fseek
139 92-stat
140 93-fread-fwrite
141 94-unsetenv
142 "
143
144 # 90: needs GNU, fails for mescc, passes for tcc
145 broken="$broken
146 7s-struct-short
147 "
148
149 # gcc not supported
150 CC=
151 set +e
152 expect=$(echo $broken | wc -w)
153 pass=0
154 fail=0
155 total=0
156 for t in $tests; do
157     if [ -z "${t/[012][0-9]-*/}" ]; then
158         LIBC=c-mini
159         MESCCLIBS="-l c-mini"
160     elif [ -z "${t/[78][0-9a-z]-*/}" ]; then
161         LIBC=c+tcc
162         MESCCLIBS="-l c+tcc"
163     elif [ -z "${t/9[0-9]-*/}" ]; then
164         LIBC=c+gnu
165         MESCCLIBS="-l c+gnu"
166     else
167         LIBC=c
168         MESCCLIBS=
169     fi
170     sh build-aux/test.sh "scaffold/tests/$t" &> scaffold/tests/"$t".log
171     r=$?
172     total=$((total+1))
173     if [ $r = 0 ]; then
174         echo $t: [OK]
175         pass=$((pass+1))
176     else
177         echo $t: [FAIL]
178         fail=$((fail+1))
179     fi
180 done
181
182 tests="
183 00_assignment
184 01_comment
185 02_printf
186 03_struct
187 04_for
188 05_array
189 06_case
190 07_function
191 08_while
192 09_do_while
193
194 10_pointer
195 11_precedence
196 12_hashdefine
197 13_integer_literals
198 14_if
199 15_recursion
200 16_nesting
201 17_enum
202 18_include
203 19_pointer_arithmetic
204
205 20_pointer_comparison
206 21_char_array
207 22_floating_point
208 23_type_coercion
209 24_math_library
210 25_quicksort
211 26_character_constants
212 27_sizeof
213 28_strings
214 29_array_address
215
216 30_hanoi
217 31_args
218 32_led
219 33_ternary_op
220 34_array_assignment
221 35_sizeof
222 36_array_initialisers
223 37_sprintf
224 38_multiple_array_index
225 39_typedef
226
227 40_stdio
228 41_hashif
229 42_function_pointer
230 43_void_param
231 44_scoped_declarations
232 45_empty_for
233 47_switch_return
234 48_nested_break
235 49_bracket_evaluation
236
237 50_logical_second_arg
238 51_static
239 52_unnamed_enum
240 54_goto
241 55_lshift_type
242 "
243
244 broken="$broken
245 18_include
246
247 22_floating_point
248 23_type_coercion
249 24_math_library
250 26_character_constants
251 27_sizeof
252 28_strings
253
254 34_array_assignment
255 39_typedef
256
257 40_stdio
258 42_function_pointer
259 49_bracket_evaluation
260 55_lshift_type
261 "
262
263 #22_floating_point       ; float
264 #23_type_coercion        ; float
265 #24_math_library         ; float
266 #27_sizeof               ; float
267 #28_strings              ; TODO: strncpy strchr strrchr memset memcpy memcmp
268 #30_hanoi                ; fails with GCC
269 #34_array_assignment     ; fails with GCC
270 #39_typedef              ;unsupported: (decl (decl-spec-list (stor-spec (typedef)) (type-spec (typename "MyFunStruct"))) (init-declr-list (init-declr (ptr-declr (pointer) (ident "MoreFunThanEver")))))
271
272 #40_stdio                ; f* functions
273 #42_function_pointer     ; f* functions
274 #49_bracket_evaluation   ; float
275
276 LIBC=c+gnu
277 MESCCLIBS="-l c+gnu"
278
279 expect=$(echo $broken | wc -w)
280 ARGS="arg1 arg2 arg3 arg4 arg5"
281 export ARGS
282 for t in $tests; do
283     if [ ! -f scaffold/tinycc/"$t.c" ]; then
284         echo ' [SKIP]'
285         continue;
286     fi
287     sh build-aux/test.sh "scaffold/tinycc/$t" &> scaffold/tinycc/"$t".log
288     r=$?
289     total=$((total+1))
290     if [ $r = 0 ]; then
291         echo $t: [OK]
292         pass=$((pass+1))
293     else
294         echo $t: [FAIL]
295         fail=$((fail+1))
296     fi
297 done
298 [ $expect != 0 ] && echo "expect: $expect"
299 [ $fail != 0 ] && echo "failed: $fail"
300 [ $fail -lt $expect ] && echo "solved: $(($expect - $fail))"
301 echo "passed: $pass"
302 echo "total:  $total"
303 if [ $fail != 0 -a $fail -gt $expect ]; then
304     echo FAILED: $fail/$total
305     exit 1
306 elif [ $fail != 0 ]; then
307     echo PASS: $pass/$total
308 else
309     echo PASS: $total
310 fi